export declare type Component = () => HTMLElement;
export declare const requestAnimationFrame: ((callback: FrameRequestCallback) => number) & typeof globalThis.requestAnimationFrame;
export declare const Components: Map<string, {
    fn: Component;
    el: HTMLElement;
}>;
export declare const Index: Map<string | RegExp, Set<string>>;
export declare const NotFound: Set<string>;
export declare const register: (...elements: Component[]) => boolean;
declare type Route = string | RegExp | undefined;
export declare const mount: <T extends {
    [key: string]: any;
}>(route: Route, page: (state?: T | undefined) => Component) => boolean;
export declare const navigate: (destination: URL | string) => void;
export declare enum EventType {
    Initialized = "initialized",
    Navigation = "navigation",
    Render = "render",
    Redraw = "redraw",
    GlobalRender = "global-render",
    BeforePageChange = "before-page-change",
    AfterPageChange = "after-page-change",
    AfterNavigationChange = "after-navigation-change"
}
export declare const goTo: (url: URL, evt?: Event | undefined) => void;
interface RenderOptions {
    prerender?: Route[];
    cache?: number;
}
export declare const prerender: (route: Route, set?: boolean) => DocumentFragment;
export declare const cache: Map<Route, DocumentFragment>;
export declare const render: (options?: RenderOptions | undefined, prev?: boolean, route?: string) => boolean;
export declare const hydrate: (i: Component) => HTMLElement;
export declare const redraw: (cmp: string | Component) => void;
export * from "../std/index";
